Subject: Re: [PATCH 6/6] net: Free skbs from irqs when possible.

From: Stephen Hemminger <[email-masked]>
Date: Tue, 18 Mar 2014 08:23:58 -0700

On Mon, 17 Mar 2014 23:27:52 -0700
[email-masked] (Eric W. Biederman) wrote:

> Add a test skb_irq_freeable to report when it is safe to free a skb
> from irq context.
> 
> It is not safe to free an skb from irq context when:
> - The skb has a destructor as some skb destructors call local_bh_disable
>   or spin_lock_bh.
> - There is xfrm state as __xfrm_state_destroy calls spin_lock_bh.
> - There is netfilter conntrack state as destroy_conntrack calls
>   spin_lock_bh.
> - If there is a refcounted dst entry on the skb, as __dst_free
>   calls spin_lock_bh.
> - If there is a frag_list, which could be a list of any skbs.
> Otherwise it appears safe to free a skb from interrupt context.
> 
> - Update the warning in skb_releae_head_state to warn about freeing
>   skb's in the wrong context.
> 
> - Update __dev_kfree_skb_irq to free all skbs that it can immediately
> 
> - Kill zap_completion_queue because there is no point going through
>   a queue of packets that are not safe to free and looking for packets
>   that are safe to free.
> 
> Signed-off-by: "Eric W. Biederman" <[email-masked]>

Why introduce the additional complexity for so little gain?
It looks like you are only optimizing for the corner case where netpoll
is cleaning up on Tx.

-1